<html>
<head>
<title>OGRE: OgreSkeletonInstance.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSkeletonInstance.h</h1><a href="OgreSkeletonInstance_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __SkeletonInstance_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __SkeletonInstance_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreSkeleton_8h.html">OgreSkeleton.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00047"></a><a class="code" href="classOgre_1_1SkeletonInstance.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049     <span class="keyword">public</span>:
<a name="l00053"></a>00053         <a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; masterCopy);
<a name="l00054"></a>00054         ~<a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a>();
<a name="l00055"></a>00055 
<a name="l00057"></a>00057         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumAnimations(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00058"></a>00058 
<a name="l00060"></a>00060         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00062"></a>00062         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* _getAnimationImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00063"></a>00063             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>** linker = 0) <span class="keyword">const</span>;
<a name="l00064"></a>00064 
<a name="l00071"></a>00071         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* createAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length);
<a name="l00072"></a>00072 
<a name="l00074"></a>00074         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00075"></a>00075             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>** linker = 0) <span class="keyword">const</span>;
<a name="l00076"></a>00076 
<a name="l00081"></a>00081         <span class="keywordtype">void</span> removeAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00085"></a>00085         <a class="code" href="classOgre_1_1TagPoint.html" title="A tagged point on a skeleton, which can be used to attach entities to on specific...">TagPoint</a>* createTagPointOnBone(<a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* bone, 
<a name="l00086"></a>00086             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> &amp;offsetOrientation = <a class="code" href="classOgre_1_1Quaternion.html#441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>, 
<a name="l00087"></a>00087             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp;offsetPosition = <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>);
<a name="l00088"></a>00088 
<a name="l00090"></a>00090         <span class="keywordtype">void</span> freeTagPoint(<a class="code" href="classOgre_1_1TagPoint.html" title="A tagged point on a skeleton, which can be used to attach entities to on specific...">TagPoint</a>* tagPoint);
<a name="l00091"></a>00091 
<a name="l00093"></a>00093         <span class="keywordtype">void</span> addLinkedSkeletonAnimationSource(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName, 
<a name="l00094"></a>00094             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00096"></a>00096         <span class="keywordtype">void</span> removeAllLinkedSkeletonAnimationSources(<span class="keywordtype">void</span>);
<a name="l00098"></a>00098         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">LinkedSkeletonAnimSourceIterator</a> 
<a name="l00099"></a>00099             getLinkedSkeletonAnimationSourceIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00100"></a>00100 
<a name="l00102"></a>00102         <span class="keywordtype">void</span> _initAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00103"></a>00103 
<a name="l00105"></a>00105         <span class="keywordtype">void</span> _refreshAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00106"></a>00106 
<a name="l00108"></a>00108         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00110"></a>00110         <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> getHandle(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00112"></a>00112         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getGroup(<span class="keywordtype">void</span>);
<a name="l00113"></a>00113 
<a name="l00114"></a>00114     <span class="keyword">protected</span>:
<a name="l00116"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#48f36b22ae7ff40e31458c15ab238a03">00116</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> mSkeleton;
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#15bb31a04288581fda04fc04280387be">00118</a>         <span class="keyword">typedef</span> std::list&lt;TagPoint*&gt; TagPointList;
<a name="l00119"></a>00119 
<a name="l00128"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#9eb0e828ad76dac4111687b772de6df1">00128</a>         TagPointList mActiveTagPoints;
<a name="l00129"></a>00129 
<a name="l00137"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#cc4b5ecb34152eff6a28efa880ae00c1">00137</a>         TagPointList mFreeTagPoints;
<a name="l00138"></a>00138 
<a name="l00140"></a><a class="code" href="classOgre_1_1SkeletonInstance.html#1ffe53c03eae391881bf2ba68110031f">00140</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mNextTagPointAutoHandle;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142         <span class="keywordtype">void</span> cloneBoneAndChildren(<a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* source, <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* parent);
<a name="l00145"></a>00145         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00148"></a>00148         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150     };
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
